// Used for shadow lookup
varying vec3 normal;
varying vec3 lightVector;
varying vec3 eyeVector;

uniform vec4 cameraPosition;
uniform vec3 lightSource;
uniform mat4 cameraInverse;
uniform mat4 cameraDirect;

void main(void) { 
	// standard transformation 
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;  
	vec4 worldPosition = gl_ModelViewMatrix * gl_Vertex;

	// Just for compiling... for now
	vec4 positionInSpace = cameraInverse * worldPosition;
	// for Lighting, it's easier to bring everyone in Eye Space:
	vec4	l = cameraDirect * vec4(lightSource, 1.0);
	l /= l.w;
	vec3 v = worldPosition.xyz / worldPosition.w;
	lightVector = normalize(l.xyz - v);
	vec4 c = cameraDirect * cameraPosition;
	c.xyz = c.xyz/c.w;
	eyeVector = normalize(c.xyz - v);
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
	gl_FrontColor = gl_Color;
} 

