#ifndef __MESSAGE__
#define __MESSAGE__

#include <QTextStream>
#include <QString>

namespace apig {

    /** This class possesses useful methods to print messages. */
    class Message {
        public:
            static void error(QString message,   bool prefix = true);
            static void error(char* message,     bool prefix = true);
            static void warning(QString message, bool prefix = true);
            static void warning(char* message,   bool prefix = true);
            static void info(QString message,    bool prefix = false);
            static void info(char* message,      bool prefix = false);
            static void debug(QString message,   bool prefix = true);
            static void debug(char* message,     bool prefix = true);
            
            static bool checkGLErrors(QString location = QString::null);
            
        private:
            static QTextStream
                errorStream,
                warningStream,
                infoStream,
                debugStream;
            static const QString
                ERROR_PREFIX,
                WARNING_PREFIX,
                INFO_PREFIX,
                DEBUG_PREFIX;
        };
    
    #define MSG_DEBUG_VAR(v) Message::debug(QString(#v " = %1").arg(v))
    #define MSG_CHECK_GL Message::checkGLErrors(QString("file %1 line %2").arg(__FILE__).arg(__LINE__))
    //#define GL_CHECK_ERROR glCheckErrors(qPrintable())
    
    }

#endif

