#ifndef __SCENE_OBJ__
#define __SCENE_OBJ__

#include "Renderable.h"
#include "Vec3.h"
#include <QString>

namespace apig {
    class Face;
    
    /** This class allows to load an render 3D scenes from OBJ files. */
    class SceneOBJ : public Renderable {
        public:
            SceneOBJ(QString fileName);
            ~SceneOBJ();
            
            virtual void init();
            virtual void render() const;
            
            bool    loaded()      const { return defined; }
            bool    ready()       const { return initialized; }
            QString getFileName() const { return fileName; }

            virtual Vec3  center() const { return sceneCenter; }
            virtual float radius() const { return sceneRadius; }
        
        private:
            QString fileName;
            bool defined;
            bool initialized;
            int nv;     // number of vertices
            int nf;     // number of faces
            Vec3 *vertex;
            Vec3 *normal;
            Face *face;
            Vec3 sceneCenter;
            float sceneRadius;
            unsigned int displist;
        };
    
    }

#endif
