#ifndef __SHADER_GLSL__
#define __SHADER_GLSL__

#include <GlewOpenGL.h>
#include <QString>

namespace apig {

    class ShaderGLSL {
        public:
            typedef enum { VERTEX, FRAGMENT } Type;
            
            // constructeur a appeler quand un contexte OpenGL a ete initialise
            // <source> contient le code source si <loadFromFile>==false, le nom du fichier source sinon
            ShaderGLSL(QString source, Type type, bool loadFromFile=true);
        
            void compile();
            void destroy();
            
            // comparaison de deux shaders a partir des id :
            bool operator==(const ShaderGLSL& s) { return id == s.id; }
            
        private:
            QString getInfoLog() const;
            
        private:
            QString fileName;   // juste pour les eventuels messages d'erreurs
            GLuint id;
            
        friend class ProgGLSL;     // pour permettre a la classe ProgrammeGLSL d'acceder a la variable <id>
        };
    
    }

#endif
